## libjpeg-turbo 1.5.1

=== CMakeLists.txt ===
#
# Setup
#

cmake_minimum_required(VERSION 2.8.11)
# Use LINK_INTERFACE_LIBRARIES instead of INTERFACE_LINK_LIBRARIES
if(POLICY CMP0022)
  cmake_policy(SET CMP0022 OLD)
endif()

project(libjpeg-turbo C)
set(VERSION 1.5.1)
string(REPLACE "." ";" VERSION_TRIPLET ${VERSION})
list(GET VERSION_TRIPLET 0 VERSION_MAJOR)
list(GET VERSION_TRIPLET 1 VERSION_MINOR)
list(GET VERSION_TRIPLET 2 VERSION_REVISION)
function(pad_number NUMBER OUTPUT_LEN)
  string(LENGTH "${${NUMBER}}" INPUT_LEN)
  if(INPUT_LEN LESS OUTPUT_LEN)
    math(EXPR ZEROES "${OUTPUT_LEN} - ${INPUT_LEN} - 1")
    set(NUM ${${NUMBER}})
    foreach(C RANGE ${ZEROES})
      set(NUM "0${NUM}")
    endforeach()
    set(${NUMBER} ${NUM} PARENT_SCOPE)
  endif()
endfunction()
pad_number(VERSION_MINOR 3)
pad_number(VERSION_REVISION 3)
set(LIBJPEG_TURBO_VERSION_NUMBER ${VERSION_MAJOR}${VERSION_MINOR}${VERSION_REVISION})

if(NOT WIN32)
  message(FATAL_ERROR "Platform not supported by this build system.  Use autotools instead.")
endif()

string(TIMESTAMP BUILD "%Y%m%d")

# This does nothing except when using MinGW.  CMAKE_BUILD_TYPE has no meaning
# in Visual Studio, and it always defaults to Debug when using NMake.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

# This only works if building from the command line.  There is currently no way
# to set a variable's value based on the build type when using Visual Studio.
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(BUILD "${BUILD}d")
endif()

message(STATUS "VERSION = ${VERSION}, BUILD = ${BUILD}")

option(WITH_SIMD "Include SIMD extensions" TRUE)
option(WITH_ARITH_ENC "Include arithmetic encoding support when emulating the libjpeg v6b API/ABI" TRUE)
option(WITH_ARITH_DEC "Include arithmetic decoding support when emulating the libjpeg v6b API/ABI" TRUE)
option(WITH_JPEG7 "Emulate libjpeg v7 API/ABI (this makes libjpeg-turbo backward incompatible with libjpeg v6b)" FALSE)
option(WITH_JPEG8 "Emulate libjpeg v8 API/ABI (this makes libjpeg-turbo backward incompatible with libjpeg v6b)" FALSE)
option(WITH_MEM_SRCDST "Include in-memory source/destination manager functions when emulating the libjpeg v6b or v7 API/ABI" TRUE)
option(WITH_TURBOJPEG "Include the TurboJPEG wrapper library and associated test programs" TRUE)
option(WITH_JAVA "Build Java wrapper for the TurboJPEG library" FALSE)
option(WITH_12BIT "Encode/decode JPEG images with 12-bit samples (implies WITH_SIMD=0 WITH_TURBOJPEG=0 WITH_ARITH_ENC=0 WITH_ARITH_DEC=0)" FALSE)
option(ENABLE_STATIC "Build static libraries" TRUE)
option(ENABLE_SHARED "Build shared libraries" TRUE)

if(WITH_12BIT)
  set(WITH_SIMD FALSE)
  set(WITH_TURBOJPEG FALSE)
  set(WITH_JAVA FALSE)
  set(WITH_ARITH_ENC FALSE)
  set(WITH_ARITH_DEC FALSE)
  set(BITS_IN_JSAMPLE 12)
  message(STATUS "12-bit JPEG support enabled")
else()
  set(BITS_IN_JSAMPLE 8)
endif()

if(WITH_JPEG8 OR WITH_JPEG7)
  set(WITH_ARITH_ENC 1)
  set(WITH_ARITH_DEC 1)
endif()
if(WITH_JPEG8)
  set(WITH_MEM_SRCDST 1)
endif()

if(WITH_ARITH_ENC)
  set(C_ARITH_CODING_SUPPORTED 1)
  message(STATUS "Arithmetic encoding support enabled")
else()
  message(STATUS "Arithmetic encoding support disabled")
endif()

if(WITH_ARITH_DEC)
  set(D_ARITH_CODING_SUPPORTED 1)
  message(STATUS "Arithmetic decoding support enabled")
else()
  message(STATUS "Arithmetic decoding support disabled")
endif()

if(WITH_TURBOJPEG)
  message(STATUS "TurboJPEG C wrapper enabled")
else()
  message(STATUS "TurboJPEG C wrapper disabled")
endif()

if(WITH_JAVA)
  message(STATUS "TurboJPEG Java wrapper enabled")
else()
  message(STATUS "TurboJPEG Java wrapper disabled")
endif()

set(SO_AGE 0)
if(WITH_MEM_SRCDST)
  set(SO_AGE 1)
endif()

set(JPEG_LIB_VERSION 62)
set(DLL_VERSION ${JPEG_LIB_VERSION})
set(FULLVERSION ${DLL_VERSION}.${SO_AGE}.0)
if(WITH_JPEG8)
  set(JPEG_LIB_VERSION 80)
  set(DLL_VERSION 8)
  set(FULLVERSION ${DLL_VERSION}.0.2)
  message(STATUS "Emulating libjpeg v8 API/ABI")
elseif(WITH_JPEG7)
  set(JPEG_LIB_VERSION 70)
  set(DLL_VERSION 7)
  set(FULLVERSION ${DLL_VERSION}.${SO_AGE}.0)
  message(STATUS "Emulating libjpeg v7 API/ABI")
endif(WITH_JPEG8)

if(WITH_MEM_SRCDST)
  set(MEM_SRCDST_SUPPORTED 1)
  message(STATUS "In-memory source/destination managers enabled")
else()
  message(STATUS "In-memory source/destination managers disabled")
endif()

if(MSVC)
  option(WITH_CRT_DLL
    "Link all libjpeg-turbo libraries and executables with the C run-time DLL (msvcr*.dll) instead of the static C run-time library (libcmt*.lib.)  The default is to use the C run-time DLL only with the libraries and executables that need it."
    FALSE)
  if(NOT WITH_CRT_DLL)
    # Use the static C library for all build types
    foreach(var CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${var} "${${var}}")
      endif()
    endforeach()
  endif()
  add_definitions(-W3 -wd4996)
endif()

# Detect whether compiler is 64-bit
if(MSVC AND CMAKE_CL_64)
  set(SIMD_X86_64 1)
  set(64BIT 1)
elseif(CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(SIMD_X86_64 1)
  set(64BIT 1)
endif()

if(64BIT)
  message(STATUS "64-bit build")
else()
  message(STATUS "32-bit build")
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  if(MSVC)
    set(CMAKE_INSTALL_PREFIX_DEFAULT ${CMAKE_PROJECT_NAME})
  else()
    set(CMAKE_INSTALL_PREFIX_DEFAULT ${CMAKE_PROJECT_NAME}-gcc)
  endif()
  if(64BIT)
    set(CMAKE_INSTALL_PREFIX_DEFAULT ${CMAKE_INSTALL_PREFIX_DEFAULT}64)
  endif()
  set(CMAKE_INSTALL_PREFIX "c:/${CMAKE_INSTALL_PREFIX_DEFAULT}" CACHE PATH
    "Directory into which to install libjpeg-turbo (default: c:/${CMAKE_INSTALL_PREFIX_DEFAULT})"
    FORCE)
endif()

message(STATUS "Install directory = ${CMAKE_INSTALL_PREFIX}")

configure_file(win/jconfig.h.in jconfig.h)
configure_file(win/jconfigint.h.in jconfigint.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR})

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UC)

set(EFFECTIVE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_UC}}")
message(STATUS "Compiler flags = ${EFFECTIVE_C_FLAGS}")

set(EFFECTIVE_LD_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE_UC}}")
message(STATUS "Linker flags = ${EFFECTIVE_LD_FLAGS}")

if(WITH_JAVA)
  find_package(Java)
  find_package(JNI)
  if(DEFINED JAVACFLAGS)
    message(STATUS "Java compiler flags = ${JAVACFLAGS}")
  endif()
endif()


#
# Targets
#

set(JPEG_SOURCES jcapimin.c jcapistd.c jccoefct.c jccolor.c jcdctmgr.c jchuff.c
  jcinit.c jcmainct.c jcmarker.c jcmaster.c jcomapi.c jcparam.c jcphuff.c
  jcprepct.c jcsample.c jctrans.c jdapimin.c jdapistd.c jdatadst.c jdatasrc.c
  jdcoefct.c jdcolor.c jddctmgr.c jdhuff.c jdinput.c jdmainct.c jdmarker.c
  jdmaster.c jdmerge.c jdphuff.c jdpostct.c jdsample.c jdtrans.c jerror.c
  jfdctflt.c jfdctfst.c jfdctint.c jidctflt.c jidctfst.c jidctint.c jidctred.c
  jquant1.c jquant2.c jutils.c jmemmgr.c jmemnobs.c)

if(WITH_ARITH_ENC OR WITH_ARITH_DEC)
  set(JPEG_SOURCES ${JPEG_SOURCES} jaricom.c)
endif()

if(WITH_ARITH_ENC)
  set(JPEG_SOURCES ${JPEG_SOURCES} jcarith.c)
endif()

if(WITH_ARITH_DEC)
  set(JPEG_SOURCES ${JPEG_SOURCES} jdarith.c)
endif()

if(WITH_SIMD)
  add_definitions(-DWITH_SIMD)
  add_subdirectory(simd)
  if(SIMD_X86_64)
    set(JPEG_SOURCES ${JPEG_SOURCES} simd/jsimd_x86_64.c)
  else()
    set(JPEG_SOURCES ${JPEG_SOURCES} simd/jsimd_i386.c)
  endif()
  # This tells CMake that the "source" files haven't been generated yet
  set_source_files_properties(${SIMD_OBJS} PROPERTIES GENERATED 1)
else()
  set(JPEG_SOURCES ${JPEG_SOURCES} jsimd_none.c)
  message(STATUS "Not using SIMD acceleration")
endif()

if(WITH_JAVA)
  add_subdirectory(java)
  set(ENABLE_SHARED TRUE)
endif()

if(ENABLE_SHARED)
  add_subdirectory(sharedlib)
endif()

if(ENABLE_STATIC OR WITH_TURBOJPEG)
  add_library(jpeg-static STATIC ${JPEG_SOURCES} ${SIMD_OBJS})
  if(NOT MSVC)
    set_target_properties(jpeg-static PROPERTIES OUTPUT_NAME jpeg)
  endif()
  if(WITH_SIMD)
    add_dependencies(jpeg-static simd)
  endif()
endif()

if(WITH_TURBOJPEG)
  set(TURBOJPEG_SOURCES turbojpeg.c transupp.c jdatadst-tj.c jdatasrc-tj.c)
  if(WITH_JAVA)
    set(TURBOJPEG_SOURCES ${TURBOJPEG_SOURCES} turbojpeg-jni.c)
    include_directories(${JAVA_INCLUDE_PATH} ${JAVA_INCLUDE_PATH2})
  endif()

  if(ENABLE_SHARED)
    add_library(turbojpeg SHARED ${TURBOJPEG_SOURCES})
    set_target_properties(turbojpeg PROPERTIES DEFINE_SYMBOL DLLDEFINE)
    if(MINGW)
      set_target_properties(turbojpeg PROPERTIES LINK_FLAGS -Wl,--kill-at)
    endif()
    target_link_libraries(turbojpeg jpeg-static)
    set_target_properties(turbojpeg PROPERTIES LINK_INTERFACE_LIBRARIES "")

    add_executable(tjunittest tjunittest.c tjutil.c)
    target_link_libraries(tjunittest turbojpeg)

    add_executable(tjbench tjbench.c bmp.c tjutil.c rdbmp.c rdppm.c wrbmp.c
      wrppm.c)
    target_link_libraries(tjbench turbojpeg jpeg-static)
    set_property(TARGET tjbench PROPERTY COMPILE_FLAGS
      "-DBMP_SUPPORTED -DPPM_SUPPORTED")
  endif()

  if(ENABLE_STATIC)
    add_library(turbojpeg-static STATIC ${JPEG_SOURCES} ${SIMD_OBJS}
      turbojpeg.c transupp.c jdatadst-tj.c jdatasrc-tj.c)
    if(NOT MSVC)
      set_target_properties(turbojpeg-static PROPERTIES OUTPUT_NAME turbojpeg)
    endif()
    if(WITH_SIMD)
      add_dependencies(turbojpeg-static simd)
    endif()

    add_executable(tjunittest-static tjunittest.c tjutil.c)
    target_link_libraries(tjunittest-static turbojpeg-static)

    add_executable(tjbench-static tjbench.c bmp.c tjutil.c rdbmp.c rdppm.c
      wrbmp.c wrppm.c)
    target_link_libraries(tjbench-static turbojpeg-static jpeg-static)
    set_property(TARGET tjbench-static PROPERTY COMPILE_FLAGS
      "-DBMP_SUPPORTED -DPPM_SUPPORTED")
  endif()
endif()

if(WITH_12BIT)
  set(COMPILE_FLAGS "-DGIF_SUPPORTED -DPPM_SUPPORTED -DUSE_SETMODE")
else()
  set(COMPILE_FLAGS "-DBMP_SUPPORTED -DGIF_SUPPORTED -DPPM_SUPPORTED -DTARGA_SUPPORTED -DUSE_SETMODE")
  set(CJPEG_BMP_SOURCES rdbmp.c rdtarga.c)
  set(DJPEG_BMP_SOURCES wrbmp.c wrtarga.c)
endif()

if(ENABLE_STATIC)
  add_executable(cjpeg-static cjpeg.c cdjpeg.c rdgif.c rdppm.c rdswitch.c
    ${CJPEG_BMP_SOURCES})
  set_property(TARGET cjpeg-static PROPERTY COMPILE_FLAGS ${COMPILE_FLAGS})
  target_link_libraries(cjpeg-static jpeg-static)

  add_executable(djpeg-static djpeg.c cdjpeg.c rdcolmap.c rdswitch.c wrgif.c
    wrppm.c ${DJPEG_BMP_SOURCES})
  set_property(TARGET djpeg-static PROPERTY COMPILE_FLAGS ${COMPILE_FLAGS})
  target_link_libraries(djpeg-static jpeg-static)

  add_executable(jpegtran-static jpegtran.c cdjpeg.c rdswitch.c transupp.c)
  target_link_libraries(jpegtran-static jpeg-static)
  set_property(TARGET jpegtran-static PROPERTY COMPILE_FLAGS "-DUSE_SETMODE")
endif()

add_executable(rdjpgcom rdjpgcom.c)

add_executable(wrjpgcom wrjpgcom.c)


#
# Tests
#

add_subdirectory(md5)

if(MSVC_IDE)
  set(OBJDIR "\${CTEST_CONFIGURATION_TYPE}/")
else()
  set(OBJDIR "")
endif()

enable_testing()

if(WITH_12BIT)
  set(TESTORIG testorig12.jpg)
  set(MD5_JPEG_RGB_ISLOW 9620f424569594bb9242b48498ad801f)
  set(MD5_PPM_RGB_ISLOW f3301d2219783b8b3d942b7239fa50c0)
  set(MD5_JPEG_422_IFAST_OPT 7322e3bd2f127f7de4b40d4480ce60e4)
  set(MD5_PPM_422_IFAST 79807fa552899e66a04708f533e16950)
  set(MD5_PPM_422M_IFAST 07737bfe8a7c1c87aaa393a0098d16b0)
  set(MD5_JPEG_420_IFAST_Q100_PROG a1da220b5604081863a504297ed59e55)
  set(MD5_PPM_420_Q100_IFAST 1b3730122709f53d007255e8dfd3305e)
  set(MD5_PPM_420M_Q100_IFAST 980a1a3c5bf9510022869d30b7d26566)
  set(MD5_JPEG_GRAY_ISLOW 235c90707b16e2e069f37c888b2636d9)
  set(MD5_PPM_GRAY_ISLOW 7213c10af507ad467da5578ca5ee1fca)
  set(MD5_PPM_GRAY_ISLOW_RGB e96ee81c30a6ed422d466338bd3de65d)
  set(MD5_JPEG_420S_IFAST_OPT 7af8e60be4d9c227ec63ac9b6630855e)
  set(MD5_JPEG_3x2_FLOAT_PROG a8c17daf77b457725ec929e215b603f8)

=== simd/CMakeLists.txt ===
if(NOT DEFINED NASM)
  set(NASM nasm CACHE FILEPATH "Path to NASM/YASM executable")
endif()

if(SIMD_X86_64)
  set(NAFLAGS -fwin64 -DWIN64 -D__x86_64__)
else()
  if(BORLAND)
    set(NAFLAGS -fobj -DOBJ32)
  else()
    set(NAFLAGS -fwin32 -DWIN32)
  endif()
endif()
set(NAFLAGS ${NAFLAGS} -I${CMAKE_SOURCE_DIR}/win/ -I${CMAKE_CURRENT_SOURCE_DIR}/)

# This only works if building from the command line.  There is currently no way
# to set a variable's value based on the build type when using the MSVC IDE.
if(CMAKE_BUILD_TYPE STREQUAL "Debug"
  OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  set(NAFLAGS ${NAFLAGS} -g)
endif()

if(SIMD_X86_64)
  set(SIMD_BASENAMES jfdctflt-sse-64 jccolor-sse2-64 jcgray-sse2-64
    jchuff-sse2-64 jcsample-sse2-64 jdcolor-sse2-64 jdmerge-sse2-64
    jdsample-sse2-64 jfdctfst-sse2-64 jfdctint-sse2-64 jidctflt-sse2-64
    jidctfst-sse2-64 jidctint-sse2-64 jidctred-sse2-64 jquantf-sse2-64
    jquanti-sse2-64)
  message(STATUS "Building x86_64 SIMD extensions")
else()
  set(SIMD_BASENAMES jsimdcpu jfdctflt-3dn jidctflt-3dn jquant-3dn jccolor-mmx
    jcgray-mmx jcsample-mmx jdcolor-mmx jdmerge-mmx jdsample-mmx jfdctfst-mmx
    jfdctint-mmx jidctfst-mmx jidctint-mmx jidctred-mmx jquant-mmx jfdctflt-sse
    jidctflt-sse jquant-sse jccolor-sse2 jcgray-sse2 jchuff-sse2 jcsample-sse2
    jdcolor-sse2 jdmerge-sse2 jdsample-sse2 jfdctfst-sse2 jfdctint-sse2
    jidctflt-sse2 jidctfst-sse2 jidctint-sse2 jidctred-sse2 jquantf-sse2
    jquanti-sse2)
  message(STATUS "Building i386 SIMD extensions")
endif()

if(MSVC_IDE)
  set(OBJDIR "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}")
else()
  set(OBJDIR ${CMAKE_CURRENT_BINARY_DIR})
endif()

file(GLOB INC_FILES *.inc)

foreach(file ${SIMD_BASENAMES})
  set(DEPFILE "")
  set(SIMD_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${file}.asm)
  if(${file} MATCHES jccolor)
    set(DEPFILE ${file})
    string(REGEX REPLACE "jccolor" "jccolext" DEPFILE ${DEPFILE})
    set(DEPFILE ${CMAKE_CURRENT_SOURCE_DIR}/${DEPFILE}.asm)
  endif()
  if(${file} MATCHES jcgray)
    set(DEPFILE ${file})
    string(REGEX REPLACE "jcgray" "jcgryext" DEPFILE ${DEPFILE})
    set(DEPFILE ${CMAKE_CURRENT_SOURCE_DIR}/${DEPFILE}.asm)
  endif()
  if(${file} MATCHES jdcolor)
    set(DEPFILE ${file})
    string(REGEX REPLACE "jdcolor" "jdcolext" DEPFILE ${DEPFILE})
    set(DEPFILE ${CMAKE_CURRENT_SOURCE_DIR}/${DEPFILE}.asm)
  endif()
  if(${file} MATCHES jdmerge)
    set(DEPFILE ${file})
    string(REGEX REPLACE "jdmerge" "jdmrgext" DEPFILE ${DEPFILE})
    set(DEPFILE ${CMAKE_CURRENT_SOURCE_DIR}/${DEPFILE}.asm)
  endif()
  set(SIMD_OBJ ${OBJDIR}/${file}.obj)
  add_custom_command(OUTPUT ${SIMD_OBJ}
    DEPENDS ${SIMD_SRC} ${DEPFILE} ${INC_FILES}
    COMMAND ${NASM} ${NAFLAGS} ${SIMD_SRC} -o${SIMD_OBJ})
  set(SIMD_OBJS ${SIMD_OBJS} ${SIMD_OBJ})
endforeach()

set(SIMD_OBJS ${SIMD_OBJS} PARENT_SCOPE)
add_custom_target(simd DEPENDS ${SIMD_OBJS})

=== debian/changelog ===
libjpeg-turbo (1:1.5.1-2mx15+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 10 Nov 2016 13:46:25 -0800

libjpeg-turbo (1:1.5.1-2) unstable; urgency=medium

  * Declare env on MIPS on first use (Courtesy of Aurelien Jarno) (Closes: #841129)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Oct 2016 15:51:27 +0200

libjpeg-turbo (1:1.5.1-1) unstable; urgency=medium

  * Imported Upstream version 1.5.1

 -- Ondřej Surý <ondrej@debian.org>  Wed, 21 Sep 2016 14:01:53 +0200

libjpeg-turbo (1:1.5.0-1) unstable; urgency=medium

  * Imported Upstream version 1.5.0
  * Remove MIPS SIMD patch; merged upstream
  * Install libturbojpeg.pc to libturbojpeg0-dev
  * README is now README.md
  * Add the extra documentation to the package(s)
  * Migrate to automatic dbgsym packages and remove get-orig-source, uscan
    works just fine
  * Bump standards version to 3.9.8 (no change)
  * Bump debhelper compat to 10, but don't bump debhelper depends to allow
    backports
  * doc/html/search/all_74.js is not missing source

 -- Ondřej Surý <ondrej@debian.org>  Wed, 08 Jun 2016 11:05:07 +0200

libjpeg-turbo (1:1.4.2-2) unstable; urgency=medium

  * Only disable SIMD on x32 instead of enabling it everywhere else

 -- Ondřej Surý <ondrej@debian.org>  Mon, 01 Feb 2016 18:13:32 +0100

libjpeg-turbo (1:1.4.2-1) unstable; urgency=medium

  * Imported Upstream version 1.4.2
  * Reproducible builds are now achieved with --with-build-date
  * Rebase remaining patch on top of 1.4.2 release

 -- Ondřej Surý <ondrej@debian.org>  Mon, 01 Feb 2016 16:30:16 +0100

libjpeg-turbo (1:1.4.1-2) unstable; urgency=medium

  * Fix build error in MIPS SIMD when compiling with -mfpxx (Closes: #795845)
  * Add versioned provides for libjpeg62 (Closes: #787938)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 26 Aug 2015 17:34:30 +0200

libjpeg-turbo (1:1.4.1-1) unstable; urgency=medium

  * Imported Upstream version 1.4.1
  * All patches except the reproducible build has been merged upstream

 -- Ondřej Surý <ondrej@debian.org>  Tue, 28 Jul 2015 08:23:22 +0200

libjpeg-turbo (1:1.4.0-7) unstable; urgency=medium

  * Add patch to make builds reproducible (Closes: #782893)
  * Adjust gbp.conf for releasing 1.4.0 to unstable
  * Upload to unstable

 -- Ondřej Surý <ondrej@debian.org>  Sun, 10 May 2015 22:14:45 +0200

libjpeg-turbo (1:1.4.0-6) experimental; urgency=medium

  * Remove architecture list in nasm B-D (Closes: #776877)

 -- Ondřej Surý <ondrej@debian.org>  Mon, 02 Feb 2015 21:12:29 +0100

libjpeg-turbo (1:1.4.0-5) experimental; urgency=medium

  * Add missing init_simd() call in jsimd_can_h2v[12]_merged_upsample
    functions in mips(el) SIMD and thus we can enable SIMD on mips(el)
    See https://sourceforge.net/p/libjpeg-turbo/bugs/83/ for a long
    version.
  
 -- Ondřej Surý <ondrej@debian.org>  Wed, 21 Jan 2015 17:13:23 +0100

libjpeg-turbo (1:1.4.0-4) experimental; urgency=medium

  * Enable hardening=+all in d/rules
  * Preserve user supplied CFLAGS by using foo_CPPFLAGS instead of
    foo_CFLAGS in Makefile.am

 -- Ondřej Surý <ondrej@debian.org>  Fri, 16 Jan 2015 09:15:29 +0100

libjpeg-turbo (1:1.4.0-3) experimental; urgency=medium

  * Disable SIMD on mips as well (and match x32 against DEB_HOST_ARCH)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 15 Jan 2015 10:41:33 +0100

libjpeg-turbo (1:1.4.0-2) experimental; urgency=medium

  * Disable float tests (see https://sourceforge.net/p/libjpeg-turbo/bugs/83/
    for background)
  * Disable SIMD also on mipsel
  * Use architecture.mk for setting dpkg variables

 -- Ondřej Surý <ondrej@debian.org>  Wed, 14 Jan 2015 13:22:18 +0100

libjpeg-turbo (1:1.4.0-1) experimental; urgency=medium

  * Add gbp.conf for experimental (1.4) branch
  * New upstream version 1.4.0
  * Remove all Debian patches; merged upstream
  * Bump libturbojpeg SONAME to 0 to align with upstream and thus renamed
    libturbojpeg1* packages to libturbojpeg0*.

 -- Ondřej Surý <ondrej@debian.org>  Mon, 12 Jan 2015 12:11:11 +0100

=== debian/control ===
Source: libjpeg-turbo
Priority: optional
Section: graphics
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>
Build-Depends: debhelper (>= 9),
	       dh-autoreconf,
	       nasm
Standards-Version: 3.9.8
Homepage: http://www.libjpeg-turbo.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/libjpeg-turbo.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libjpeg-turbo.git

Package: libjpeg-dev
Architecture: all
Section: libdevel
Depends: libjpeg62-turbo-dev (>= ${source:Version}),
 	 ${misc:Depends}
Conflicts: libjpeg62-dev,
	   libjpeg7-dev,
	   libjpeg8-dev,
	   libjpeg9-dev
Description: Development files for the JPEG library [dummy package]
 This package depends on default Debian implementation of
 libjpeg.so.62 JPEG library.

Package: libjpeg62-turbo-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libc-dev,
	 libjpeg62-turbo (= ${binary:Version}),
	 ${misc:Depends}
Conflicts: libjpeg62-dev,
	   libjpeg7-dev,
	   libjpeg8-dev,
	   libjpeg9-dev
Replaces: libjpeg62-dev,
	  libjpeg7-dev,
	  libjpeg8-dev,
	  libjpeg9-dev
Provides: libjpeg-dev
Description: Development files for the libjpeg-turbo JPEG library
 The libjpeg-turbo JPEG library is a library for handling JPEG files.
 .
 libjpeg-turbo is a JPEG image codec that uses SIMD instructions (MMX,
 SSE2, NEON) to accelerate baseline JPEG compression and decompression
 on x86, x86-64, and ARM systems.  The libjpeg-turbo JPEG library is
 an API/ABI compatible with the IJG JPEG library.
 .
 This package contains the static library, headers and documentation.

Package: libjpeg62-turbo
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
	 ${shlibs:Depends}
Conflicts: libjpeg62
Replaces: libjpeg62
Provides: libjpeg62 (= ${binary:Version})
Description: libjpeg-turbo JPEG runtime library
 The libjpeg-turbo JPEG library is a library for handling JPEG files.
 .
 libjpeg-turbo is a JPEG image codec that uses SIMD instructions (MMX,
 SSE2, NEON) to accelerate baseline JPEG compression and decompression
 on x86, x86-64, and ARM systems.  The libjpeg-turbo JPEG library is
 an API/ABI compatible with the IJG JPEG library.
 .
 This package contains the shared runtime library.

Package: libturbojpeg0
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Replaces: libturbojpeg
Conflicts: libturbojpeg,
	   libjpeg-turbo8
Description: TurboJPEG runtime library - SIMD optimized
 The libjpeg-turbo JPEG library is a library for handling JPEG files.
 .
 libjpeg-turbo is a JPEG image codec that uses SIMD instructions (MMX,
 SSE2, NEON) to accelerate baseline JPEG compression and decompression
 on x86, x86-64, and ARM systems.
 .
 This package contains the TurboJPEG shared runtime library.

Package: libturbojpeg0-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libturbojpeg0 (= ${binary:Version}),
	 ${misc:Depends},
Replaces: libturbojpeg-dev,
Conflicts: libturbojpeg-dev,
	   libturbojpeg1-dev,
	   libjpeg-turbo8-dev,
Provides: libturbojpeg-dev
Description: Development files for the TurboJPEG library
 The libjpeg-turbo JPEG library is a library for handling JPEG files.
 .
 libjpeg-turbo is a JPEG image codec that uses SIMD instructions (MMX,
 SSE2, NEON) to accelerate baseline JPEG compression and decompression
 on x86, x86-64, and ARM systems.
 .
 This package contains the static library, headers and documentation for
 the TurboJPEG library.

Package: libjpeg-turbo-progs
Architecture: any
Depends: ${misc:Depends},
	 ${shlibs:Depends}
Conflicts: libjpeg-progs
Replaces: libjpeg-progs
Provides: libjpeg-progs
Description: Programs for manipulating JPEG files
 This package contains programs for manipulating JPEG files from the
 libjpeg-turbo JPEG library:
  * cjpeg/djpeg: convert to/from the JPEG file format
  * rdjpgcom/wrjpgcom: read/write comments in JPEG files
  * jpegtran: lossless transformations of JPEG files
  * jpegexiforient/exifautotran: manipulate EXIF orientation tag
  * tjbench: a simple JPEG benchmarking tool

## libjpeg-turbo 1.5.2

=== debian/changelog ===
libjpeg-turbo (1:1.5.2-2~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 09 Nov 2019 15:34:03 -0800

libjpeg-turbo (1:1.5.2-2) unstable; urgency=medium

  * Drop env declaration patch on mips to fix FTBFS on mips
  * Add jpeg_simd_cpu_support symbol that exists only on any-i386 archs

 -- Ondřej Surý <ondrej@debian.org>  Fri, 25 Aug 2017 10:27:48 +0200

libjpeg-turbo (1:1.5.2-1) unstable; urgency=medium

  * New upstream version 1.5.2
  * Stop using custom libjpeg.pc (Closes: #860219)
  * Update gbp-dch -> dch section in gbp.conf
  * Update libjpeg62-turbo symbols
  * Set DPKG_GENSYMBOLS_CHECK_LEVEL to 4 in d/rules

 -- Ondřej Surý <ondrej@debian.org>  Fri, 25 Aug 2017 09:16:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Priority: optional
 Section: graphics
 Maintainer: Steven Pusser <stevep@mxlinux.org>
-Bugs: mailto: <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>
 Build-Depends: debhelper (>= 9),

## libjpeg-turbo 1.5.2.6

=== debian/changelog ===
libjpeg-turbo (1:1.5.2.6-1+dde) unstable; urgency=medium

  * update

 -- Ondřej Surý <ondrej@debian.org>  Thu, 01 Apr 2021 21:31:42 +0800

libjpeg-turbo (1:1.5.2-2+deb10u1) buster; urgency=medium

  * CVE-2018-1152  (Closes: #902950)
  * CVE-2018-14498 (Closes: #924678)
  * CVE-2019-2201
  * CVE-2020-13790 (Closes: #962829)

 -- Moritz Mühlenhoff <jmm@debian.org>  Wed, 07 Oct 2020 22:25:43 +0200

libjpeg-turbo (1:1.5.2.5-1+dde) unstable; urgency=medium

  * fix  CVE-2018-14498 
  * fix  CVE-2019-2201

 -- liujianqiang <liujianqiang@uniontech .com>  Sun, 13 Dec 2020 12:03:21 +0800

libjpeg-turbo (1:1.5.2.4-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2018-11813

 -- zhouzilong <zhouzilong@uniontech.com>  Mon, 31 Aug 2020 12:15:35 +0800

libjpeg-turbo (1:1.5.2-3+dde2) unstable; urgency=medium

  * Non-maintainer upload.
  *    rebuild

 -- liuyong <liuyong@deepin.com>  Fri, 03 Jul 2020 10:58:51 +0800

libjpeg-turbo (1:1.5.2-3+dde) unstable; urgency=medium

  * add 0001-Merge-loongson-mmi-optimizations.patch

 -- jin bo <jinbo-hf@loongson.cn>  Thu, 30 Apr 2020 15:13:48 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# To enable all, uncomment following line
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifneq (,$(filter mips mipsel mips64 mips64el,$(DEB_HOST_GNU_CPU)))
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
else
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -ffloat-store
endif
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

include /usr/share/dpkg/default.mk

CFLAGS ?= $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS ?= $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS ?= $(shell dpkg-buildflags --get LDFLAGS)
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -Wall
endif

ifneq (,$(filter mips mipsel mips64 mips64el,$(DEB_HOST_GNU_CPU)))
	CFLAGS += -march=loongson3a -O3
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CC = gcc
else
CC = $(DEB_HOST_GNU_TYPE)-gcc
endif

SIMD_BROKEN_ARCHS = x32

ifeq (,$(filter $(DEB_HOST_ARCH), $(SIMD_BROKEN_ARCHS)))
  DISABLE_SIMD=
else
  DISABLE_SIMD=--without-simd
endif

%:
	dh $@ --parallel --with autoreconf -O--dbgsym-migration='libjpeg-turbo-progs-dbg (<< 1.5.0-1~), libjpeg62-turbo-dbg (<< 1.5.0-1~), libturbojpeg0-dbg (<< 1.5.0-1~)'

override_dh_auto_configure:
	dh_auto_configure -- --with-build-date=$(DEB_VERSION) $(DISABLE_SIMD)

override_dh_auto_build:
	dh_auto_build -- V=1
	$(MAKE) -C debian/extra CC=$(CC) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" V=1

override_dh_auto_clean:
	$(MAKE) -C debian/extra clean
	if [ -e Makefile ]; then $(MAKE) testclean; fi
	dh_auto_clean
	rm -f simd/jsimdcfg.inc

override_dh_auto_install:
	dh_auto_install
	# Install extra utilities
	$(MAKE) -C debian/extra install prefix=/usr DESTDIR=$(CURDIR)/debian/tmp
	# Install manual page for tjbench.1
	install -m 644 debian/tjbench.1 $(CURDIR)/debian/tmp/usr/share/man/man1/
	# Fix jconfig.h for MultiArch
	rm -f debian/tmp/usr/include/jconfig.h
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)
	sed -e "s/#\(undef\|define\) HAVE_\(LOCALE\|\(STD\(DEF\|LIB\)\)\)_H 1//g" \
		jconfig.h > debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/jconfig.h

override_dh_install:
	dh_install -X.la -X/usr/share/doc --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs -plibjpeg62-turbo-dev change.log
	dh_installchangelogs -Nlibjpeg62-turbo-dev

## libjpeg-turbo 2.0.0

=== debian/changelog ===
libjpeg-turbo (2.0.0-0ubuntu2) cosmic; urgency=medium

  * Fix build dependencies.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 17 Sep 2018 12:04:40 +0200

libjpeg-turbo (2.0.0-0ubuntu1) cosmic; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 17 Sep 2018 11:03:11 +0200

libjpeg-turbo (1.5.2-0ubuntu5) artful; urgency=medium

  * Revert the last upload.
  * Move libturbojpeg.a to the libturbojpeg0-dev package.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Oct 2017 07:07:23 +0200

libjpeg-turbo (1.5.2-0ubuntu4) artful; urgency=medium

  * Drop libturbojpeg.a static library in libturbojpeg0-dev package,
    already ship in jpeg-turbo8 package (this fixes the installability
    issue. The static library is still in libjpeg-turbo8-dev
    for retro-compatibility, the dynamic one is in
    libturbojpeg0-dev and libturbojpeg packages.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Oct 2017 16:48:35 +0200

libjpeg-turbo (1.5.2-0ubuntu3) artful; urgency=medium

  * libturbojpeg0-dev: Depend on libturbojpeg0-dev.
  * libturbojpeg0-dev: Include the turbojpeg.h header here.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Sep 2017 18:10:01 +0200

libjpeg-turbo (1.5.2-0ubuntu2) artful; urgency=medium

  * libturbojpeg0-dev: Drop conflict with libjpeg-turbo8-dev, depend
    on it instead, and leave the header files libjpeg-turbo8-dev.
    This stops pulling the legacy turbojpeg API into main. See the README
    in the sources ("Using libjpeg-turbo").
    There is no reason to pull libturbojpeg0-dev and libturbojpeg0 into main.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Sep 2017 12:40:49 +0200

libjpeg-turbo (1.5.2-0ubuntu1) artful; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Sep 2017 14:17:22 +0200

libjpeg-turbo (1.5.1-0ubuntu2) artful; urgency=medium

  * Install turbojpeg development file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Sep 2017 12:49:04 +0200

libjpeg-turbo (1.5.1-0ubuntu1) zesty; urgency=medium

  * New upstream version.
  * Keep the Ubuntu packaging.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Nov 2016 16:58:27 +0100

libjpeg-turbo (1.5.0-0ubuntu1) yakkety; urgency=medium

  * New upstream version.
  * Keep the Ubuntu packaging.
  * Update symbols file.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Aug 2016 13:36:10 +0200

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# for architecture dependent variables and changelog vars
vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS               := $(shell dpkg-architecture)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions

CFLAGS ?= $(shell dpkg-buildflags --get CFLAGS)
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -Wall
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CC = gcc
else
CC = $(DEB_HOST_GNU_TYPE)-gcc
endif

%:
	dh $@ --list-missing --parallel --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -v -- -G'Unix Makefiles' -DWITH_JPEG8=1 -DWITH_JAVA=1

override_dh_auto_build:
	dh_auto_build -v
	$(MAKE) -C debian/extra CC=$(CC) CFLAGS="$(CFLAGS) -Wall"

override_dh_install:
	$(MAKE) -C debian/extra install prefix=/usr DESTDIR=$(CURDIR)/debian/tmp
	: # fix jconfig.h 
	rm -f debian/tmp/usr/include/jconfig.h
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)
	sed -e "s/#\(undef\|define\) HAVE_\(LOCALE\|\(STD\(DEF\|LIB\)\)\)_H 1//g" \
		obj-*/jconfig.h > debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/jconfig.h
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
	sed -e "s/@VERSION@/$(VERSION)/;s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/" \
		debian/libjpeg.pc.in \
		> debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libjpeg.pc
	cp obj-*/tjunittest debian/tmp/usr/bin/.
	for i in $$(chrpath -k debian/tmp/usr/bin/* debian/tmp/usr/lib/*/lib*.so.* 2>/dev/null | awk -F: '/R(UN)?PATH=/ {print $$1}'); do \
		[ -h $$i ] && continue; \
		echo "removing: $$i"; \
		chrpath --delete $$i; \
		echo "removed RPATH/RUNPATH: $$i"; \
	done
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs -plibjpeg-turbo8-dev change.log
	dh_installchangelogs -Nlibjpeg-turbo8-dev

override_dh_strip:
	dh_strip -plibjpeg-turbo8 --dbg-package=libjpeg-turbo8-dbg
	dh_strip -Nlibjpeg-turbo8 libjpeg-turbo8-dbg

override_dh_makeshlibs:
	: # keep the original libjpeg symbol version
	dh_makeshlibs -- -v8c
	: # ... and mark libjpeg-turbo only symbols with a different version
	sed -i "$$(for i in $$(cat debian/libjpeg-turbo-only.symbols); do echo "/^ $$i/s/8c$$/8c-2ubuntu5~/;"; done)" debian/libjpeg-turbo8/DEBIAN/symbols

override_dh_auto_test:

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C debian/extra clean
	rm -f simd/jsimdcfg.inc

deb_source := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
svn_rev := $(shell dpkg-parsechangelog | sed -rne 's,^Version: .*[+~]svn([0-9]+).*,\1,p')
upstream_version := $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

.PHONY: get-orig-source
get-orig-source:
	rm -rf $(deb_source)-$(upstream_version).orig
	rm -f $(deb_source)-$(upstream_version).orig.tar.gz
	svn -q export -r $(svn_rev) https://libjpeg-turbo.svn.sourceforge.net/svnroot/libjpeg-turbo/trunk \
		$(deb_source)-$(upstream_version).orig
	GZIP=--best tar -cz --owner root --group root --mode a+rX \
	     -f $(deb_source)_$(upstream_version).orig.tar.gz \
	     $(deb_source)-$(upstream_version).orig
	rm -r $(deb_source)-$(upstream_version).orig
